#include "../inc/draw.h"
#include "../inc/dictatorship.h"
#include <microfx/microfx.h>
#include <microfx/ext/strtools.h>

#define T_WIDTH 21
#define T_HEIGHT 7

const char help[] = "The screen you saw before, is the main screen. By pressing"
"various F keys you can access to other screens.\n- F1 propaganda\n- F2"
"censorship\n- F3 stats\n- F4 industry\n- F5 taxes & militia\n- F6"
"relations & army\nI hope you'll enjoy playing this game!"
"Waaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa";

char buffer[20];

void keyvalid(int key) {
    int k = kgetkey();
    while(k != key) k = kgetkey();
    while(k == key) k = kgetkey();
}

void new_dictatorship(Dictatorship *dictatorship) {
    slocate(1, 1, "Welcome to this game.");
    slocate(1, 3, "Your goal is to make");
    slocate(1, 4, "a dictatorship that");
    slocate(1, 5, "is working very well.");
    slocate(1, 6, "EXE to continue ...");
    supdate();
    keyvalid(KCEXE);
    gstrask(dictatorship->name, "Enter the name of dict.", 15);
}

void warning(void) {
    sclear();
    slocate(7, 1, "WARNING");
    slocate(1, 3, "THIS GAME SHOULD NOT");
    slocate(2, 4, "BE TAKEN SERIOUSLY");
    slocate(6, 6, "Press EXE");
    supdate();
    keyvalid(KCEXE);
}

void dtext(char *text, char *title, int w) {
    int i, start = 0, x, y, n, len;
    char tmp[2];
    bool toobig;
    char c;
    tmp[1] = '\0';
    while(start < (int)strlen(text)){
        sclear();
        slocate(1, 1, title);
        x=1;
        y=2;
        toobig = FALSE;
        for(i=start;i<(int)strlen(text);i++){
            c = text[i];
            /* Get the lenght of the next word if we need to. */
            if(c == ' ' || c == '-' || c == '\n'){
                n = i;
                len = 0;
                toobig = FALSE;
                while(text[n] != ' ' && n<(int)strlen(text)){
                    len++;
                    n++;
                }
                /* len--; */
                itoa(x, buffer);
                slocate(1+(y-2)*3, 1, buffer);
            }
            /* Copy pasta that on the screen !!! */
            if(c == ' ' || c == '-' || c == '\n'){
                if(len>w) toobig = TRUE;
                if(x+len>w){
                    y++;
                    x=0;
                }
            }
            if(c == '\n'){
                y++;
                x=0;
            }
            if(toobig && x>=w-1){ /* If the word is bigger than the
                screen */
                slocate(w, y, "-");
                y++;
                x=0;
                tmp[0] = c;
                slocate(x, y, tmp);
            }else{
                tmp[0] = c;
                slocate(x, y, tmp);
            }
            x++;
            /* Check if we need to stop */
            if(y>T_HEIGHT-1){
                break;
            }
        }
        start = i;
        if(start >= (int)strlen(text)) slocate(1, 7, "EXE to quit");
        else slocate(1, 7, "EXE to continue");
        supdate();
        while(!kcheck(KCEXE));
        while(kcheck(KCEXE));
    }
}

void draw_bar(int sx, int sy, int percents, int w, char *text) {
    char buffer[6];
    int bw = ((w-4)*100/100*percents)/100;
    stextmini(sx, sy, text);
    srect(sx, sy+7, sx+w, sy+7+5);
    srect(sx+2, sy+7+2, sx+2+bw, sy+7+5-2);
    itoa(percents, buffer);
    strcat(buffer, "%");
    stextmini(sx+w+4, sy+7, buffer);
}

/* Diffrent screens */

void draw_propaganda(Dictatorship *dictatorship) {
    while(!kcheck(KCMENU)){
        sclear();
        draw_bar(1, 1, dictatorship->happyness_gov, 40, "Happyness with your gov.:");
        supdate();
    }
}

void draw_production(void);

void draw_main(Dictatorship *dictatorship) {
    int key;
    slocate(1, 1, "==");
    slocate(4, 1, dictatorship->name);
    slocate(20, 1, "==");
    key = kgetkey();
    if(key == KCF1){
        dtext((char *)help, "======= HELP  =======", T_WIDTH);
    }
    if(key ==  KCF2){
        draw_propaganda(dictatorship);
    }
}
