#include <microfx/microfx.h>
#include <microfx/ext/img.h>
#include "../gfx/screens.h"
#include "../inc/dictatorship.h"
#include "../inc/draw.h"

Dictatorship dictatorship;

int main(void) {
	int key = 0;
	while(kisdown());
	warning();
	sclear();
	simage(0, 0, 128, 64, (unsigned char *)&title, SNORMAL);
	supdate();
	keyvalid(KCEXE);
	sclear();
	slocate(1, 3, "Initializing ...");
	supdate();
	init_dictatorship(&dictatorship, S_LEFT);
	new_dictatorship(&dictatorship);
	key = kgetkey();
	while(1){
		sclear();
		draw_main(&dictatorship);
		supdate();
		key = kgetkey();
		if(key == KCEXIT) break;
	}
	return 1;
}
